%% Solve Hanging Catenary problem - template script
% Lindon Roberts, 2019

% To do:
% 1. Understand the files provided and what they do
% 2. Define lower and upper bounds for the variables (line 42)
% 3. Choose relevant solver and write code to use it (line 49)
% 4. Inspect outputs and understand what you have (line 57)
% 5. Set options for solver (line 44)

clear, close all

% Parameters
m = 1; % mass
g = 9.8; % gravity
n = 16; % number of beams = n+1
L = 1; % beam lengths
gamma = 0.95; % horizontal bridge length / total beam lengths

% Our convention for input variables is:
%   x is large vector of size 3*(n+2)
%   The first n+2 elements are the x-coordinates: x0, ..., xnp1 = x(1:n+2)
%   The next n+2 elements are the y-coordinates: y0, ..., ynp1 = x(n+3:2*n+4)
%   The last n+2 elements are the z-coordinates: z0, ..., znp1 = x(2*n+5:3*n+6)

% Choose a sensible initial guess (allowed to be infeasible)
xcoords0 = linspace(0,gamma*(n+1)*L,n+2)'; % evenly distributed
ycoords0 = zeros(n+2,1);
zcoords0 = zeros(n+2,1);
x0 = [xcoords0; ycoords0; zcoords0];

% Create anonymous functions for the objective and constraints
obj = @(x)objfun(x, m, g);
nonlcon = @(x)nlconstr(x, L);

A = []; b = []; % no linear inequality constraints
Aeq = []; beq = []; % no linear equality constraints

% Bound constraints lb <= x <= ub
lb = -1e20*ones(3*(n+2), 1); % default to large negative value
ub = 1e20*ones(3*(n+2), 1); % default to large positive value
% TODO: define appropriate bound constraints

% TODO: define options for solver using
%   options = optimoptions('matlab_solver_name'); % start with defaults
% and then set options with
%   options = optimoptions(options, 'OptionToChange', value_to_use);

% TODO: call solver...
xmin = x0; % dummy line, replace with actual optimisation routine

% Split out results into (x,y,z) vectors
xcoords = xmin(1:n+2);
ycoords = xmin(n+3:2*n+4);
zcoords = xmin(2*n+5:3*n+6);

% TODO: Inspect the outputs and understand what information you have
